//
//  HNViewController.m
//  HMCellButton
//
//  Created by wanghao on 2017/5/16.
//  Copyright © 2017年 HMHN. All rights reserved.
//  The code is provided by Na Zhilong

#import "HNViewController.h"
#import "HNTableViewCell.h"

@interface HNViewController ()<UITableViewDelegate,UITableViewDataSource>

@property (strong, nonatomic) UITableView *tableView;
@property (strong, nonatomic) NSArray *dataArray;
@property (strong, nonatomic) NSMutableArray *buttonArray;

@end

@implementation HNViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    self.dataArray = @[@"ww",@"dsa",@"fsa",@"fsa",@"gds",@"da",@"sad",@"df",@"gd",@"afa",@"ww",@"dsa",@"fsa",@"fsa",@"gds",@"da",@"sad",@"df",@"gd",@"afa"];
    self.buttonArray = [NSMutableArray new];
    for (NSString *string in self.dataArray) {
        NSMutableDictionary * dic = @{@"isButton" : @"0"};
        [self.buttonArray addObject:dic];
    }
    self.tableView = [[UITableView alloc]initWithFrame:[UIScreen mainScreen].bounds style:UITableViewStyleGrouped];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    [self.view addSubview:self.tableView];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark : TableVIew Delegate
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return self.dataArray.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    HNTableViewCell *cell = [self.tableView dequeueReusableCellWithIdentifier:@"HNTableViewCell"];
    if (!cell) {
        cell = [[[NSBundle mainBundle]loadNibNamed:@"HNTableViewCell" owner:self options:nil]firstObject];
    }
    NSString *isButtonString = self.buttonArray[indexPath.row][@"isButton"];
    [cell.chooseButton setTitle:self.dataArray[indexPath.row] forState:UIControlStateNormal];
    if ([isButtonString isEqualToString:@"0"]) {
        [cell.chooseButton setTitle:@"下载" forState:UIControlStateNormal];
        cell.chooseButton.backgroundColor = [UIColor magentaColor];
    }else{
        [cell.chooseButton setTitle:@"已下载" forState:UIControlStateNormal];
        cell.chooseButton.backgroundColor = [UIColor cyanColor];
    }
    cell.chooseButton.tag = 1000+indexPath.row;
    [cell.chooseButton addTarget:self action:@selector(chooseButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    cell.selectionStyle = UITableViewCellEditingStyleNone;
    cell.backgroundColor = [UIColor colorWithRed:arc4random_uniform(250)/255.0 green:arc4random_uniform(250)/255.0 blue:arc4random_uniform(250)/255.0 alpha:1];
    return cell;
}

- (void)chooseButtonClick:(UIButton *)sender{
    NSInteger indexRow = sender.tag-1000;
    NSString *isButtonString = self.buttonArray[indexRow][@"isButton"];
    if ([isButtonString isEqualToString:@"1"]) {
        self.buttonArray[indexRow]  = @{@"isButton":@"0"};
        [sender setTitle:@"下载" forState:UIControlStateNormal];
        sender.backgroundColor = [UIColor magentaColor];
    }else{

        self.buttonArray[indexRow]  = @{@"isButton":@"1"};
        [sender setTitle:@"已下载" forState:UIControlStateNormal];
        sender.backgroundColor = [UIColor cyanColor];
    }
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 100;
}
@end
